public class Sort_2012 // = Sortieren (und Suchen) von Kommazahlen
  // R. Krell, 14.9.2012/16.12.2012/29.1.2013 fr www.r-krell.de bzw. www.r-krell.de/if-java-c.htm
{
  double [] reihe  = new double [200];  // Original, wird erzeugt, sortiert & ausgegeben
  double [] backup = new double [200];  // Backup zur spteren Wiederherstellung des Originals
  
  int anzahl = 0;                       // Fllgrad der Reihung(en) reihe (und backup)
  
  public void flleZufllig (int wieviele)
  {                                     // fllt die reihe von links mit der in wieviele
    for(int i=0; i<wieviele; i++)       // angegeben Anzahl von zuflligen Kommazahlen
    {
      reihe[i] = zufallszahl();         // erzeugt Zufallszahlen zwischen 0.0 und 9.9, s.u.
    }
    anzahl=wieviele;                    // setzt anzahl auf den richtigen, neuen Wert
  }
  
  private double zufallszahl()
  {
    return (((int)(100*Math.random()))/10.0);  // Zufallszahl zw. 0.0 und 9.9
  }                                     // mit einer Nachkommastelle
  
  public void sichern()
  {
    backup = reihe.clone();             // kopiert die Werte der Original-reihe in backup
  }
  
  public void wiederherstellen()
  {
    reihe = backup.clone();             // setzt reihe auf die Werte aus dem backup zurck
  }
  
  public String zeigeAlle()             // bergibt den Inhalt der Reihe als lange Textzeile
  {                                     // fr die Anzeige in einer Oberflche
    String ausgabe = "Reihe :";         // oder die Ausgabe mit System.out.println(..)
    for(int i= 0; i < anzahl;i++)
    {
      ausgabe= ausgabe+"  "+reihe[i];
    }
    return (ausgabe);
  }
  
  //-------------------- Hilfmethode fr die folgenden Sortierverfahren --------
  
  private void tausche (int i, int j)  // tauscht die Inhalte(!),
  // die in der reihe an den Positionen i und j stehen/standen
  {
    double hilfe = reihe[i];
    reihe[i] = reihe[j];
    reihe[j] = hilfe;
  }
  
  
  //-------------------- Einfache Sortierverfahren, iterativ --------------------
  
  public void bubbleSort()  // Sortieren durch Vertauschung direkter Nachbarn
  {                         // Erste Version mit fester Durchgangszahl
    for (int durchg = 1; durchg < anzahl; durchg++) // mehrere Durchgnge..
    {
      for(int i=0; i<anzahl-durchg; i++) //.. die krzer werden, weil sich hinten
      {                                  // die groen Zahlen Sammeln
        if (reihe[i] > reihe [i+1])  // bei Bedarf
        {
          tausche(i, i+1);           // Vertauschen unmittelbarer Nachbarn
        }
      }
    }
  }
  
  public void bubbleSort2()   // BubbleSort Version 2: bedarfsabhngige Durchgangszahl
  {
    boolean getauscht;  // merkt sich, ob im letzten Durchgang getauscht wurde
    int durchg = 1;
    do
    {
      getauscht = false; // noch nicht getauscht
      for (int i = 0; i < anzahl-durchg; i++) // ein Durchgang
      {
        if (reihe [i] > reihe [i+1])
        {
          tausche (i, i+1);       // bei Bedarf Nachbarn tauschen
          getauscht = true;       // und Tausch merken
        }
      }
      durchg ++;       // Vorbereiten fr evtl. nchsten Durchgang
    }
    while(getauscht);  // weiterer Durchgang nur ntig, wenn im letzten
  }                    // Durchgang noch getauscht wurde
  
  public void maxSort() // Sortieren durch Auswahl -- hier des jeweils grten Elements
  {
    int maxStelle;
    for (int durchg = anzahl-1; durchg >-1; durchg --)
    {                   // rckwrts zhlen, da groe Zahlen nach hinten
      maxStelle = durchg;   // Position des bisher grten Elements
      for (int i= durchg-1; i>-1; i--)
      {
        if (reihe[i]> reihe[maxStelle]) // falls greres Element gefunden..
        {
          maxStelle = i;   //.. Position aktualisieren
        }
      }
      tausche (maxStelle,durchg); // grtes Element nach hinten tauschen
    }
  }
  
  public void minSort() // Sortieren durch Auswahl -- hier des jeweils kleinsten Elements
  {
    int minStelle;
    for (int durchg =0; durchg < anzahl-1; durchg++)
    {                   // aufsteigend, da kleine Element nach vorne kommen
      minStelle = durchg;
      for(int i=durchg+1; i<anzahl; i++)
      {
        if (reihe[i] < reihe[minStelle])
        {
          minStelle = i;
        }
      }
      tausche (minStelle,durchg);  // kleinstes Element nach vorne tauschen
    }
  }
  
  public void einSort()  // Sortieren durch Einfgen
  {
    double zwischenspeicher;  // fr vorderes Element aus unsortiertem Teil
    for (int durchg=1; durchg < anzahl; durchg++)
    {
      zwischenspeicher = reihe [durchg];  // herausnehmen
      int i = durchg-1;
      while (i >= 0 && reihe[i] > zwischenspeicher)
      {                          // grere sortierte Elemente schieben:
        reihe[i+1] = reihe[i];   // der wert von reihe[i] wird in die reihe[i+1] gesteckt
        i--;
      }
      reihe[i+1] = zwischenspeicher; // herausgenommenes Element nach vorne in erzeugte Lcke
    }
  }
  
  public void shakerSort ()  // hnlich BubbleSort, nur Hin und Her
  {
    for (int durchg = 1; durchg <= anzahl/2; durchg++)
    {
      for (int i = anzahl-durchg-1; i>=durchg-1; i--)  // Durchgang nach links
      {
        if (reihe[i] > reihe[i+1])
        {
          tausche (i, i+1);
        }                                              // frdert kleinstes Element nach links
      }
      for (int j = durchg; j < anzahl-durchg; j++)     // Durchgang nach rechts
      {
        if (reihe[j] > reihe[j+1])
        {
          tausche (j, j+1);
        }                                              // frdert grtes Element nach rechts
      }
    }
  }
  
  public void weitere ()
  {
    // ggf. weitere Verfahren, noch nicht implementiert.
    
  }
  
  
  //-------------------- Einfache Sortierverfahren, rekursiv -------------------
  
  public void bubbleSortR()
  {
    bubble_rek (1); // ruft rekursives Bubblesort ab durchgang 1 auf
  }
  
  private void bubble_rek (int durchg)
  { // weniger rekursiv als folgende Variante "bubble_rekursiv"
    if (durchg < anzahl)
    {
      for(int i=0; i<anzahl-durchg; i++)  // Schleife fr einen Durchgang
      {
        if (reihe[i] > reihe [i+1])
        {
          tausche(i, i+1);
        }
      }
      bubble_rek (durchg+1); // Rekursion nur fr nchsten Durchgang
    }
  }
  
  public void bubbleSortR1()
  {
    bubble_rekursiv (0,1); // ruft rekursives Bubblesort ab Stelle i=0 im durchgang 1 auf
  }
  
  private void bubble_rekursiv (int i, int durchg) // massiv-rekursiv
  {
    if (i < anzahl-durchg)
    {
      if (reihe[i] > reihe [i+1])
      {
        tausche(i, i+1);
      }                               // per Rekursion..
      bubble_rekursiv (i+1, durchg);  // im gleichen Durchgang zur nchsten Stelle/zum nchsten Paar
    }
    else  // hinten im Durchgang angekommen
    {
      if (durchg < anzahl)  // wenn noch ein Durchgang mglich ist
      {
        bubble_rekursiv (0, durchg+1); // vorne (bei Stelle 0) im nchsten Durchgang anfangen
      }
    }
  }
  
  
  //-------------------- Hheres Sortierverfahren: QuickSort -------------------
  
  public void quickSort ()
  {
    quick_rek (0, anzahl-1);  // startet rekursives QuickSort
  }
  
  private void quick_rek (int li, int re)
  // vgl. http://www.vogella.com/articles/JavaAlgorithmsQuicksort/article.html
  {
    //    System.out.println("Quicksort-Aufruf mit li="+li+", re="+re);
    int grn  = li;    // Index, luft von links nach rechts
    int rot   = re;    // Index, luft von rechts nach links
    double pivot = reihe[li];  // irgendein willkrlich gewhlter..
    //    double pivot = reihe[re];  // .. Inhalt aus der reihe, irgendwo
    //    double pivot = reihe[(li+re)/2];  // zwischen li und re.
    //    double pivot = (reihe[li]+reihe[re])/2.0;  // Knstliche Werte
    //    double pivot = Math.sqrt(reihe[li]*reihe[re]); // gehen auch
    
    while (grn < rot)   // offenbar auch <= mglich
    {
      while (reihe[grn] < pivot) // grn nach rechts bis zur Stelle des nchsten Tauschkandidaten
      {
        grn++;
      }
      while (reihe[rot] > pivot)  // rot nach links bis zur Stelle des nchsten Tauschkandidaten
      {
        rot--;
      }
      if (grn <= rot)
      {
        tausche (grn, rot); // Inhalte der reihe von den beiden Stellen vertauschen; nicht grn und rot selbst
        grn++;
        rot--;   // Vertauschte Inhalte sind keine Tauschkandidaten mehr
      }
    }
    // Schleife luft, bis sich grn und rot berkreuzt haben
    
    if (li<rot)
    {
      quick_rek (li, rot);   // Rekursion fr linken Teil (alles <= pivot)
    }
    if (grn < re)
    {
      quick_rek (grn, re);  // Rekursion fr rechten Teil (alles >= pivot)
    }
    // meist stoen die Teile direkt aneinander. Gelegentlich kann dazwischen
    // noch ein Element vom Wert des pivot-Elements stehen, das als
    // einzelnes Element nicht mehr sortiert werden muss!
  }
  
  
  
  //-------------------- Versch. Suchverfahren: ----------------------------
  
  public int suche1 (double gesucht)  // normale, sequentielle Suche.
  // braucht keine Sortierung und nutzt diese, falls vorhanden, auch nicht aus!
  {
    int i=0;
    while (i<anzahl && gesucht != reihe[i])
    {
      i++;
    }
    if (i<anzahl)
    {
      return (i); // gefunden an Stelle i
    }
    else
    {
      return (-1); // nicht gefunden
    }
    
  }
  
  public int suche1r (double gesucht)  // wie suche1, nur rekursiv
  {
    return (suche_rek (0, gesucht));
  }
  
  private int suche_rek (int i, double gesucht)
  {
    if (i < anzahl)
    {
      if (gesucht == reihe[i])
      {
        return (i);
      }
      else
      {
        return (suche_rek (i+1, gesucht));
      }
    }
    else
    {
      return (-1);
    }
  }
  
  public int suche1s (double gesucht)  // sequentielle Suche nur
  // fr eine aufsteigend sortierte Reihung. Minimal schneller als suche1,
  // falls gesuchtes Element nicht in der Reihung. Lohnt nicht!!
  {
    int i=0;
    while (i<anzahl && gesucht < reihe[i])
    {
      i++;
    }
    if (i<anzahl && gesucht == reihe[i])
    {
      return (i); // gefunden an Stelle i
    }
    else
    {
      return (-1); // nicht gefunden
    }
  }
  
  public int suche2 (double gesucht) // binre Suche = Suche nach dem
  // Halbierungsverfahren; nur fr aufsteigend sortierte Reihung.
  // Viel schneller als suche1, vorallem bei groer Anzahl!
  {
    int links  = 0;
    int rechts = anzahl-1;
    int mitte;
    do
    {
      mitte = (links+rechts)/2;
      if (gesucht < reihe[mitte])
      {
        rechts = mitte-1;
      }
      else
      {
        if (gesucht > reihe[mitte])
        {
          links = mitte+1;
        }
        else  // da weder < noch > wird == gefunden!
        {
          return (mitte);  // bei Erfolg wird die Methode beendet
        }
      }
    } while (links <= rechts);
    
    // do..while-Schleife endet hier nur, wenn nichts gefunden wurde:
    return(-1);
  }
  
  public int suche2r (double gesucht)
  {
    return (bin_rek (0, anzahl-1, gesucht));  // ruft rekursive binre Suche auf
  }
  
  private int bin_rek (int links, int rechts, double gesucht)
  {
    if (links <= rechts)
    {
      int mitte = (links+rechts)/2;
      if (gesucht < reihe[mitte])
      {
        return (bin_rek (links, mitte-1, gesucht));
      }
      else
      {
        if (gesucht > reihe[mitte])
        {
          return (bin_rek (mitte+1, rechts, gesucht));
        }
        else // da weder < noch > wird == gefunden!
        {
          return (mitte);
        }
      }
    }
    else
    {
      return (-1);
    }
  }
  
  
  
}